export { renderToStream };
export { disable };
export { renderToNodeStream_set };
import React from 'react';
import type { renderToPipeableStream as RenderToPipeableStream, renderToReadableStream as RenderToReadableStream } from 'react-dom/server';
import type { Pipe } from './renderToStream/createPipeWrapper';
import { SeoStrategy } from './renderToStream/resolveSeoStrategy';
import type { renderToNodeStream as renderToNodeStream_ } from './renderToStream/renderToNodeStream';
declare type Options = {
    webStream?: boolean;
    disable?: boolean;
    seoStrategy?: SeoStrategy;
    userAgent?: string;
    onBoundaryError?: (err: unknown) => void;
    renderToReadableStream?: typeof RenderToReadableStream;
    renderToPipeableStream?: typeof RenderToPipeableStream;
};
declare type Result = ({
    pipe: Pipe;
    readable: null;
} | {
    pipe: null;
    readable: ReadableStream;
}) & {
    streamEnd: Promise<boolean>;
    disabled: boolean;
    injectToStream: (chunk: unknown) => void;
};
declare function disable(): void;
declare function renderToStream(element: React.ReactNode, options?: Options): Promise<Result>;
declare function renderToNodeStream_set(renderToNodeStream: typeof renderToNodeStream_): void;
