"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.renderToNodeStream_set = exports.disable = exports.renderToStream = void 0;
const react_1 = __importDefault(require("react"));
const server_1 = __importStar(require("react-dom/server"));
const useSuspenseData_1 = require("./useAsync/useSuspenseData");
const useStream_1 = require("./useStream");
const resolveSeoStrategy_1 = require("./renderToStream/resolveSeoStrategy");
const utils_1 = require("./utils");
const renderToWebStream_1 = require("./renderToStream/renderToWebStream");
const misc_1 = require("./renderToStream/misc");
const globalObject = (0, utils_1.getGlobalObject)('renderToStream.ts', {
    renderToNodeStream: null
});
assertReact();
const globalConfig = (globalThis.__react_streaming = globalThis
    .__react_streaming || {
    disable: false
});
function disable() {
    globalConfig.disable = true;
}
exports.disable = disable;
async function renderToStream(element, options = {}) {
    var _a, _b;
    element = react_1.default.createElement(useSuspenseData_1.SuspenseData, null, element);
    let injectToStream = (chunk) => buffer.push(chunk);
    const buffer = [];
    element = react_1.default.createElement(useStream_1.StreamProvider, {
        value: {
            injectToStream: (chunk) => {
                injectToStream(chunk);
            }
        }
    }, element);
    const disable = globalConfig.disable || ((_a = options.disable) !== null && _a !== void 0 ? _a : (0, resolveSeoStrategy_1.resolveSeoStrategy)(options).disableStream);
    const webStream = (_b = options.webStream) !== null && _b !== void 0 ? _b : !globalObject.renderToNodeStream;
    (0, misc_1.debugFlow)(`disable === ${disable} && webStream === ${webStream}`);
    let result;
    const resultPartial = { disabled: disable };
    if (!webStream) {
        result = Object.assign(Object.assign({}, resultPartial), (await globalObject.renderToNodeStream(element, disable, options)));
    }
    else {
        result = Object.assign(Object.assign({}, resultPartial), (await (0, renderToWebStream_1.renderToWebStream)(element, disable, options)));
    }
    injectToStream = result.injectToStream;
    buffer.forEach((chunk) => injectToStream(chunk));
    buffer.length = 0;
    (0, misc_1.debugFlow)('promise `await renderToStream()` resolved');
    return result;
}
exports.renderToStream = renderToStream;
function renderToNodeStream_set(renderToNodeStream) {
    globalObject.renderToNodeStream = renderToNodeStream;
}
exports.renderToNodeStream_set = renderToNodeStream_set;
// To debug wrong peer dependency loading:
//  - https://stackoverflow.com/questions/21056748/seriously-debugging-node-js-cannot-find-module-xyz-abcd
//  - https://stackoverflow.com/questions/59865584/how-to-invalidate-cached-require-resolve-results
function assertReact() {
    const versionMajor = parseInt(server_1.version.split('.')[0], 10);
    (0, utils_1.assertUsage)(versionMajor >= 18, `\`react-dom@${server_1.version}\` was loaded, but react-streaming only works with React version 18 or greater.`);
    (0, utils_1.assert)(typeof server_1.default.renderToPipeableStream === 'function' ||
        typeof server_1.default.renderToReadableStream === 'function');
}
