"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertKey = exports.stringifyKey = void 0;
const stringify_1 = require("@brillout/json-serializer/stringify");
const isCallable_1 = require("../utils/isCallable");
const utils_1 = require("./utils");
function stringifyKey(key) {
    const keyString = (0, stringify_1.stringify)(key, { sortObjectKeys: true });
    return keyString;
}
exports.stringifyKey = stringifyKey;
function assertKey(keyValue) {
    (0, utils_1.assertUsage)(keyValue, `[useAsync(key, asyncFn)] You provided a \`key\` with the value \`${keyValue}\` which is forbidden.`);
    (0, utils_1.assertUsage)(!(0, isCallable_1.isCallable)(keyValue), `[useAsync(key, asyncFn)] You provided a \`key\` that is a function which is forbidden.`);
}
exports.assertKey = assertKey;
