"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.projectInfo = void 0;
const getGlobalObject_1 = require("./getGlobalObject");
const PROJECT_VERSION = '0.3.20';
const projectInfo = {
    projectName: 'react-streaming',
    projectVersion: PROJECT_VERSION,
    npmPackageName: 'react-streaming',
    githubRepository: 'https://github.com/brillout/react-streaming'
};
exports.projectInfo = projectInfo;
const { versions } = (0, getGlobalObject_1.getGlobalObject)('projectInfo.ts', {
    versions: new Set()
});
versions.add(projectInfo.projectVersion);
if (versions.size >= 2) {
    const versionsStr = Array.from(versions)
        .map((v) => `${projectInfo.projectName}@${v}`)
        .join('and');
    throw new Error(`Using different versions is forbidden, but ${versionsStr} are loaded. Make sure only one version is loaded.`);
}
